{-# LANGUAGE TypeFamilies #-}
{- |
LLVM counterpart to 'Maybe' datatype.
-}
module LLVM.Extra.Maybe (
   Maybe.T(..),
   Maybe.run,
   Maybe.fromBool,
   Maybe.toBool,
   Maybe.just,
   nothing,
   ) where

import qualified LLVM.Extra.MaybePrivate as Maybe
import LLVM.Extra.Class (Undefined, undefTuple, )


nothing :: (Undefined a) => Maybe.T a
nothing = Maybe.nothing undefTuple
